=== modified file 'bzrlib/shelf_ui.py'
--- bzrlib/shelf_ui.py	2008-12-12 06:09:44 +0000
+++ bzrlib/shelf_ui.py	2009-02-09 23:34:46 +0000
@@ -223,7 +223,10 @@
         tree, path = workingtree.WorkingTree.open_containing(directory)
         manager = tree.get_shelf_manager()
         if shelf_id is not None:
-            shelf_id = int(shelf_id)
+            try:
+                shelf_id = int(shelf_id)
+            except ValueError:
+                raise errors.InvalidShelfId(shelf_id)
         else:
             shelf_id = manager.last_shelf()
             if shelf_id is None:

